/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package it.inaf.oats.ia2.tap.utils;

import org.apache.wicket.ajax.AjaxRequestTarget;
import org.apache.wicket.ajax.form.OnChangeAjaxBehavior;
import org.apache.wicket.markup.html.form.CheckBox;
import org.apache.wicket.model.IModel;

/**
 * AjaxCheckBox class extends CheckBox class to add an univocal ID (called idString) to it.
 * The onUpdate method of the OnChangeAjaxBehavior is never called, probably because
 * it is covered by other behaviors implemented in other files directly with the
 * AjaxCheckBox instances.
 * 
 * @author pietro
 */
public class AjaxCheckBox extends CheckBox {
    
    private String idString;
    
    /**
     * AjaxCheckBox constructor
     * 
     * @param id
     * @param model 
     */
    public AjaxCheckBox(String id, IModel model)
    {
        super(id, model);
        /*
        OnChangeAjaxBehavior onChangeAjaxBehavior = new OnChangeAjaxBehavior()
        {
            //onUpdate is never called: because is it covered by another behavior?
            @Override
            protected void onUpdate(AjaxRequestTarget target)
            {
                SchemaPage schemaPage = (SchemaPage)getPage();
                String idString = getIdString();
                String[] idSplit = getIdString().split("-");
                if (idSplit.length == 2)
                {
                    if (idSplit[1].equals("checked"))
                    {
                        schemaPage.tapschema.schemasMap.get(idSplit[0])
                                .checked
                                = (boolean)getModelObject();
                    }
                }
                else if (idSplit.length == 3)
                {
                    if (idSplit[2].equals("checked"))
                    {
                        schemaPage.tapschema.schemasMap.get(idSplit[0])
                                .tablesMap.get(idSplit[1])
                                .checked
                                = (boolean)getModelObject();
                    }
                }
                else if (idSplit.length == 4)
                {
                    if (idSplit[3].equals("checked"))
                    {
                        schemaPage.tapschema.schemasMap.get(idSplit[0])
                                .tablesMap.get(idSplit[1])
                                .columnsMap.get(idSplit[2])
                                .checked
                                = (boolean)getModelObject();
                    }
                }
            }
        };
        add(onChangeAjaxBehavior);
        */
    }
    
    public String getIdString()
    {
        return idString;
    }
    
    public void setIdString(String idString)
    {
        this.idString = idString;
    }
    
}
