/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package it.inaf.oats.ia2.tap.utils;

import java.sql.Connection;
import java.sql.DriverManager;
import org.apache.wicket.ajax.AjaxRequestTarget;
import org.apache.wicket.ajax.markup.html.form.AjaxSubmitLink;
import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.form.Form;
import org.apache.wicket.markup.html.form.PasswordTextField;
import org.apache.wicket.markup.html.form.TextArea;
import org.apache.wicket.markup.html.form.TextField;
import org.apache.wicket.model.Model;

/**
 * CredentialPage class extends the default BasePage class and is the home page.
 * It obtains the MySQL credentials from the user and pass them to the SelectSchemataPage
 * with the onSubmit method of the credentialSubmit AjaxSubmitLink.
 * 
 * @author pietro
 */
public class CredentialPage extends BasePage {
    
    String hostname;
    String port;
    String username;
    String password;
        
    Form credentialForm;
    Label hostnameLabel;
    final TextField hostnameTextField;
    Label portLabel;
    final TextField portTextField;
    Label usernameLabel;
    final TextField usernameTextField;
    Label passwordLabel;
    final PasswordTextField passwordTextField;
    AjaxSubmitLink credentialSubmit;
    TextArea infoTextArea;
    
    /**
     * CredentialPage constructor
     */
    public CredentialPage()
    {
        //credential form
        credentialForm = new Form("credentialForm");
        add(credentialForm);
        
        //hostname label
        hostnameLabel = new Label("hostnameLabel", new Model("Hostname"));
        credentialForm.add(hostnameLabel);
        
        //hostname textfield
        hostnameTextField = new TextField(
                "hostnameTextField",
                Model.of(""));
        credentialForm.add(hostnameTextField);
        
        //port label
        portLabel = new Label("portLabel", new Model("Port"));
        credentialForm.add(portLabel);
        
        //port textfield
        portTextField = new TextField(
                "portTextField",
                Model.of(""));
        credentialForm.add(portTextField);
        
        //username label
        usernameLabel = new Label("usernameLabel", new Model("Username"));
        credentialForm.add(usernameLabel);
        
        //username textfield
        usernameTextField = new TextField(
                "usernameTextField",
                Model.of(""));
        credentialForm.add(usernameTextField);
        
        //password label
        passwordLabel = new Label("passwordLabel", new Model("Password"));
        credentialForm.add(passwordLabel);
        
        //password textfield
        passwordTextField = new PasswordTextField(
                "passwordTextField",
                Model.of(""));
        credentialForm.add(passwordTextField);
        
        //credential submit
        credentialSubmit = new AjaxSubmitLink(
                "credentialSubmit",
                credentialForm)
        {
            @Override
            protected void onError(AjaxRequestTarget target, Form<?> form)
            {
                
            }
            
            /**
             * onSubmit method of credentialSubmit AjaxSubmitLink get the credentials
             * from the TextFields and passes the credentials to SelectSchemataPage
             * 
             * @param target
             * @param form
             */
            @Override
            protected void onSubmit(AjaxRequestTarget target, Form<?> form)
            {
                // gets credentials from TextFields
                hostname = (String)hostnameTextField.getModelObject();
                port = (String)portTextField.getModelObject();
                username = (String)usernameTextField.getModelObject();
                password = (String)passwordTextField.getModelObject();

                String url = "jdbc:mysql://" + hostname + ":" + port + "/";
                Connection connection = null;
                try
                {
                    // opens the connection to MySQL on hostname
                    Class.forName("com.mysql.jdbc.Driver");
                    connection = DriverManager.getConnection(
                            url,
                            username,
                            password
                    );
                    
                    // passes the credentials to SelectSchemataPage
                    SelectSchemataPage selectSchemataPage = new SelectSchemataPage(
                            target,
                            form,
                            hostname,
                            port,
                            username,
                            password
                    );
                    setResponsePage(selectSchemataPage);
                }
                catch (Exception exception)
                {
                    infoTextArea.setModelObject((String)exception.getMessage());
                    exception.printStackTrace();
                }
                finally
                {
                    try
                    {
                        connection.close();
                    }
                    catch (Exception exception)
                    {
                        exception.printStackTrace();
                    }
                }
                target.add(infoTextArea);
            }
        };
        credentialForm.add(credentialSubmit);
        
        //info textarea
        infoTextArea = new TextArea("infoTextArea", Model.of(""));
        infoTextArea.setOutputMarkupPlaceholderTag(true);
        infoTextArea.setEnabled(false);
        credentialForm.add(infoTextArea);
    }
        
}
