/*
 * HomePage.java
 *
 * Created on 7 gennaio 2013, 8.33
 */

package it.inaf.oats.ia2.tap.utils;           

import it.inaf.oats.ia2.tap.utils.tapschema.Schema;
import it.inaf.oats.ia2.tap.utils.tapschema.Table;
import it.inaf.oats.ia2.tap.utils.tapschema.TapSchema;
import java.io.File;
import java.sql.*;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;
import org.apache.wicket.Component;
import org.apache.wicket.ajax.AjaxRequestTarget;
import org.apache.wicket.ajax.form.AjaxFormChoiceComponentUpdatingBehavior;
import org.apache.wicket.ajax.markup.html.AjaxFallbackLink;
import org.apache.wicket.ajax.markup.html.form.AjaxFallbackButton;
import org.apache.wicket.ajax.markup.html.form.AjaxSubmitLink;
import org.apache.wicket.behavior.AbstractBehavior;
import org.apache.wicket.extensions.ajax.markup.html.repeater.data.table.AjaxFallbackDefaultDataTable;
import org.apache.wicket.extensions.ajax.markup.html.tabs.AjaxTabbedPanel;
import org.apache.wicket.extensions.markup.html.repeater.data.grid.ICellPopulator;
import org.apache.wicket.extensions.markup.html.repeater.data.table.AbstractColumn;
import org.apache.wicket.extensions.markup.html.repeater.data.table.IColumn;
import org.apache.wicket.extensions.markup.html.repeater.data.table.PropertyColumn;
import org.apache.wicket.extensions.markup.html.repeater.util.SortableDataProvider;
import org.apache.wicket.extensions.markup.html.tabs.AbstractTab;
import org.apache.wicket.extensions.markup.html.tabs.ITab;
import org.apache.wicket.extensions.markup.html.tabs.TabbedPanel;
import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.form.*;
import org.apache.wicket.markup.html.form.upload.FileUpload;
import org.apache.wicket.markup.html.form.upload.FileUploadField;
import org.apache.wicket.markup.html.link.ExternalLink;
import org.apache.wicket.markup.html.link.Link;
import org.apache.wicket.markup.html.panel.FeedbackPanel;
import org.apache.wicket.markup.html.panel.Panel;
import org.apache.wicket.markup.repeater.Item;
import org.apache.wicket.model.IModel;
import org.apache.wicket.model.LoadableDetachableModel;
import org.apache.wicket.model.Model;
import org.apache.wicket.model.PropertyModel;

public class HomePage extends BasePage {
    
    String server;
    String port;
    String username;
    String password;
    List<String> schemataList;
    List<String> tapschemaList;
    String tapschemaName;
    
    final List<ITab> schemataTabs;
    final AjaxTabbedPanel schemataTabbedPanel;
    
    Form selectSchemataForm;
    ArrayList<String> selectedList;
    final ListMultipleChoice<String> schemataListChoice;
    final IModel<String> radioModel;
    ArrayList<String> selectedDrop;
    final DropDownChoice<String> tapschemaDropDownChoice;
    final TextField tapschemaText;
    final AjaxSubmitLink editTapschemaSubmit;
    final AjaxSubmitLink createTapschemaSubmit;
    RadioGroup<String> tapschemaRadioGroup;
    ArrayList<String> TYPES;
    final String selectedRadio;
    RadioChoice<String> tapschemaRadio;
    
    Form loadSchemataForm;
    Label serverLabel;
    final TextField serverText;
    Label portLabel;
    final TextField portText;
    Label usernameLabel;
    final TextField usernameText;
    Label passwordLabel;
    final PasswordTextField passwordText;
    AjaxSubmitLink loadSchemataSubmit;

    public HomePage()
    {
        schemataList = new ArrayList<String>();       
        tapschemaList = new ArrayList<String>();
        
        //schemata AjaxTabbedPanel
        schemataTabs = new ArrayList<ITab>();
        schemataTabbedPanel = new AjaxTabbedPanel("schemataTabbedPanel", schemataTabs);
        schemataTabbedPanel.setOutputMarkupPlaceholderTag(true);
        add(schemataTabbedPanel);   
                
        
        
        //selectschemata form
        selectSchemataForm = new Form("selectSchemataForm");
        
        selectedList = new ArrayList<String>(
		Arrays.asList(new String[] { }));
        //schemata listchoice
        schemataListChoice = new ListMultipleChoice<String>(
                "schemataListChoice",
                new Model(selectedList),
                schemataList);
        schemataListChoice.setOutputMarkupPlaceholderTag(true);
        
        //model for tapschemaRadioGroup
        radioModel = new Model<String>("Existing Tapschema");
        
        selectedDrop = new ArrayList<String>(
		Arrays.asList(new String[] { }));
        //tapschema dropdownchoice
        tapschemaDropDownChoice = new DropDownChoice<String>(
                "tapschemaDropDownChoice",
                new Model(selectedDrop),
                tapschemaList);
        tapschemaDropDownChoice.setOutputMarkupPlaceholderTag(true);
        tapschemaDropDownChoice.add(new AbstractBehavior()
        {
            @Override
            public void onConfigure(Component component)
            {
                if (radioModel.getObject().equals("Existing Tapschema"))
                {
                    component.setVisible(true);
                }
                else
                {
                    component.setVisible(false);
                }
            }
        });
        
        //tapschema textfield
        tapschemaText = new TextField(
                "tapschemaText",
                Model.of(""));
        tapschemaText.setOutputMarkupPlaceholderTag(true);
        tapschemaText.add(new AbstractBehavior()
        {
            @Override
            public void onConfigure(Component component)
            {
                if (radioModel.getObject().equals("New Tapschema"))
                {
                    component.setVisible(true);
                }
                else
                {
                    component.setVisible(false);
                }
            }
        });
                        
        //edit tapschema AjaxSubmitLink
        editTapschemaSubmit = new AjaxSubmitLink(
                "editTapschemaSubmit",
                selectSchemataForm)
        {
            @Override
            protected void onError(AjaxRequestTarget target, Form<?> form)
            {
                
            }
            
            @Override
            protected void onSubmit(final AjaxRequestTarget target, Form<?> form)
            {
                try
                {
                    tapschemaName = tapschemaDropDownChoice.getModelObject();
                    UpdateTapSchema updateTapSchema = new UpdateTapSchema();
                    //populate tapschema
                    Collection<String> selectedDatabases = schemataListChoice.getModelObject();
                    for (String databaseName : selectedDatabases)
                    {
                        //updateTapSchema.populateTapSchemaDatabase(server, port, username, password, tapschemaName, databaseName);
                    }

                    loadSchemata(target, form);
                    loadTabbedPanel(target, form);
                }
                catch (Exception exception)
                {
                    exception.printStackTrace();
                }
            }
        };
        editTapschemaSubmit.setOutputMarkupPlaceholderTag(true);
        editTapschemaSubmit.add(new AbstractBehavior()
        {
            @Override
            public void onConfigure(Component component)
            {
                if (radioModel.getObject().equals("Existing Tapschema"))
                {
                    component.setVisible(true);
                }
                else
                {
                    component.setVisible(false);
                }
            }
        });
        
        //create tapschema AjaxSubmitLink
        createTapschemaSubmit = new AjaxSubmitLink(
                "createTapschemaSubmit",
                selectSchemataForm)
        {
            @Override
            protected void onError(AjaxRequestTarget target, Form<?> form)
            {
                
            }
            
            @Override
            protected void onSubmit(AjaxRequestTarget target, Form<?> form)
            {
                try
                {
                    //create tapschema
                    tapschemaName = (String)tapschemaText.getModelObject();
                    UpdateTapSchema updateTapSchema = new UpdateTapSchema();
                    updateTapSchema.createTapSchemaDatabase(server, port, username, password, tapschemaName);

                    //populate tapschema
                    Collection<String> selectedDatabases = schemataListChoice.getModelObject();
                    for (String databaseName : selectedDatabases)
                    {
                        //updateTapSchema.populateTapSchemaDatabase(server, port, username, password, tapschemaName, databaseName);
                    }

                    loadSchemata(target, form);
                    loadTabbedPanel(target, form);
                }
                catch (Exception exception)
                {
                    exception.printStackTrace();
                }
            }
        };
        createTapschemaSubmit.setOutputMarkupPlaceholderTag(true);
        createTapschemaSubmit.add(new AbstractBehavior()
        {
            @Override
            public void onConfigure(Component component)
            {
                if (radioModel.getObject().equals("New Tapschema"))
                {
                    component.setVisible(true);
                }
                else
                {
                    component.setVisible(false);
                }
            }
        });
        
        //tapschema RadioGroup
        tapschemaRadioGroup = new RadioGroup("tapschemaRadioGroup", radioModel );
        tapschemaRadioGroup.add(new AjaxFormChoiceComponentUpdatingBehavior()
        {
            @Override
            protected void onUpdate(AjaxRequestTarget target)
            {
                if (radioModel.getObject().equals("Existing Tapschema"))
                {
                    tapschemaDropDownChoice.setVisible(true);
                    tapschemaText.setVisible(false);
                    editTapschemaSubmit.setVisible(true);
                    createTapschemaSubmit.setVisible(false);
                }
                else
                {
                    tapschemaDropDownChoice.setVisible(false);
                    tapschemaText.setVisible(true);
                    editTapschemaSubmit.setVisible(false);
                    createTapschemaSubmit.setVisible(true);
                }
                target.add(tapschemaDropDownChoice);
                target.add(tapschemaText);
                target.add(editTapschemaSubmit);
                target.add(createTapschemaSubmit);
            }
        });
        tapschemaRadioGroup.add(new Radio<String>("radioExisting", Model.of("Existing Tapschema")));
        tapschemaRadioGroup.add(new Radio<String>("radioNew", Model.of("New Tapschema")));
        tapschemaRadioGroup.add(tapschemaDropDownChoice);
        tapschemaRadioGroup.add(tapschemaText);
        tapschemaRadioGroup.add(editTapschemaSubmit);
        tapschemaRadioGroup.add(createTapschemaSubmit);
        
	TYPES = new ArrayList<String>(
                Arrays.asList(new String[] { "Existing Tapschema", "New Tapschema" }));
	selectedRadio = "Existing Tapschema";
        //tapschema radiochoice
        tapschemaRadio = new RadioChoice<String>(
				"tapschemaRadio", new Model(selectedRadio), TYPES);
        
        
        
        
        
        //loadschemata form
        loadSchemataForm = new Form("loadSchemataForm");
        
        //server label
        serverLabel = new Label("serverLabel", new Model("Server"));
        loadSchemataForm.add(serverLabel);
        
        //server textfield
        serverText = new TextField(
                "serverText",
                Model.of(""));
        loadSchemataForm.add(serverText);
        
        //port label
        portLabel = new Label("portLabel", new Model("Port"));
        loadSchemataForm.add(portLabel);
        
        //port textfield
        portText = new TextField(
                "portText",
                Model.of(""));
        loadSchemataForm.add(portText);
        
        //username label
        usernameLabel = new Label("usernameLabel", new Model("Username"));
        loadSchemataForm.add(usernameLabel);
        
        //username textfield
        usernameText = new TextField(
                "usernameText",
                Model.of(""));
        loadSchemataForm.add(usernameText);
        
        //password label
        passwordLabel = new Label("passwordLabel", new Model("Password"));
        loadSchemataForm.add(passwordLabel);
        
        //password textfield
        passwordText = new PasswordTextField(
                "passwordText",
                Model.of(""));
        loadSchemataForm.add(passwordText);
        
        //load schemata submit
        loadSchemataSubmit = new AjaxSubmitLink(
        //AjaxFallbackButton loadschematasubmit = new AjaxFallbackButton(
                "loadSchemataSubmit",
                loadSchemataForm)
        {
            @Override
            protected void onError(AjaxRequestTarget target, Form<?> form)
            {
                
            }
            
            @Override
            protected void onSubmit(AjaxRequestTarget target, Form<?> form)
            {
                loadSchemata(target, form);
            }
        };
        loadSchemataForm.add(loadSchemataSubmit);
        
        add(loadSchemataForm);
        
        
        selectSchemataForm.add(schemataListChoice);        
        selectSchemataForm.add(tapschemaRadioGroup);
        add(selectSchemataForm);
               
    }

    public void loadSchemata(AjaxRequestTarget target, Form<?> form)
    {
        server = (String)serverText.getModelObject();
        port = (String)portText.getModelObject();
        username = (String)usernameText.getModelObject();
        password = (String)passwordText.getModelObject();

        String url = "jdbc:mysql://" + server + ":" + port + "/";
        Connection connection = null;
        Statement statement = null;
        ResultSet resultSet = null;
        try
        {
            Class.forName("com.mysql.jdbc.Driver");
            connection = DriverManager.getConnection(
                    url,
                    username,
                    password
            );
            statement = connection.createStatement();
            String queryString = "SHOW DATABASES;";
            resultSet = statement.executeQuery(queryString);
            schemataList.removeAll(schemataList);
            while (resultSet.next())
            {
                schemataList.add(resultSet.getString(1)); 
            }
            schemataListChoice.setChoices(schemataList);
            target.add(schemataListChoice);
        }
        catch (Exception exception)
        {
            exception.printStackTrace();
        }
        finally
        {
            try
            {
                resultSet.close();
                statement.close();
                connection.close();
            }
            catch (Exception exception)
            {
                exception.printStackTrace();
            }
        }

        //find tapschema
        try
        {
            tapschemaList.removeAll(tapschemaList);
            Class.forName("com.mysql.jdbc.Driver");
            connection = DriverManager.getConnection(
                    url,
                    username,
                    password
            );
            for (String schema : schemataList)
            {
                statement = connection.createStatement();
                String queryString = "SHOW TABLES FROM " + schema + ";";
                resultSet = statement.executeQuery(queryString);
                boolean schemas = false;
                boolean tables = false;
                boolean columns = false;
                boolean keys = false;
                boolean key_columns = false;
                while (resultSet.next())
                {
                    if (resultSet.getString(1).equals("schemas"))
                    {
                        schemas = true;
                    }
                    else if (resultSet.getString(1).equals("tables"))
                    {
                        tables = true;
                    }
                    else if (resultSet.getString(1).equals("columns"))
                    {
                        columns = true;
                    }
                    else if (resultSet.getString(1).equals("keys"))
                    {
                        keys = true;
                    }
                    else if (resultSet.getString(1).equals("key_columns"))
                    {
                        key_columns = true;
                    }
                }
                if ((schemas == true) && 
                        (tables == true) &&
                        (columns == true) &&
                        (keys == true) &&
                        (key_columns == true))
                {
                    tapschemaList.add(schema);
                }
            }
            tapschemaDropDownChoice.setChoices(tapschemaList);
            target.add(tapschemaDropDownChoice);
        }
        catch (Exception exception)
        {
            exception.printStackTrace();
        }
        finally
        {
            try
            {
                resultSet.close();
                statement.close();
                connection.close();
            }
            catch (Exception exception)
            {
                exception.printStackTrace();
            }
        }
    }
    
    public void loadTabbedPanel(final AjaxRequestTarget target, final Form<?> form)
    {
        //select schemas from selected tapschema
        String url = "jdbc:mysql://" + server + ":" + port + "/";
        Connection connection = null;
        Statement statement = null;
        ResultSet resultSet = null;
        try
        {
            Class.forName("com.mysql.jdbc.Driver");
            connection = DriverManager.getConnection(
                    url,
                    username,
                    password
            );
            statement = connection.createStatement();
            tapschemaName = (String)tapschemaDropDownChoice.getModelObject();
            String queryString = "SELECT * FROM " + tapschemaName + ".`schemas`;";
            resultSet = statement.executeQuery(queryString);

            //create schemataTabs dynamically
            schemataTabs.removeAll(schemataTabs);
            while (resultSet.next())
            {
                final String schema_name = resultSet.getString("schema_name");
                final String utype = resultSet.getString("utype");
                final String description = resultSet.getString("description");

                schemataTabs.add(new AbstractTab(new Model<String>(schema_name))
                {
                    @Override
                    public Panel getPanel(String panelId)
                    {
                        SchemaPanel schemaPanel = new SchemaPanel(
                                panelId,
                                server,
                                port,
                                username,
                                password,
                                tapschemaName,
                                new TapSchema(),
                                new Schema());
                        schemaPanel.setOutputMarkupPlaceholderTag(true);
                        
                        populateTableTabs(
                                target,
                                form,
                                schema_name,
                                schemaPanel);
                            
                        return schemaPanel;
                    }
                });
            }
            target.add(schemataTabbedPanel);                    
        }
        catch (Exception exception)
        {
            exception.printStackTrace();
        }
        finally
        {
            try
            {
                resultSet.close();
                statement.close();
                connection.close();
            }
            catch (Exception exception)
            {
                exception.printStackTrace();
            }
        }
    }
    
    public void populateTableTabs(
            AjaxRequestTarget target,
            Form<?> form,
            final String schema_name,
            SchemaPanel schemaPanel)
    {
        //select tables from selected schema
        String url = "jdbc:mysql://" + server + ":" + port + "/";
        Connection connection = null;
        Statement statement = null;
        ResultSet resultSet = null;
        try
        {
            Class.forName("com.mysql.jdbc.Driver");
            connection = DriverManager.getConnection(
                    url,
                    username,
                    password
            );
            statement = connection.createStatement();
            String queryString = "SELECT * FROM " + tapschemaName + ".tables " + 
                    "WHERE schema_name='" + schema_name + "';";
            resultSet = statement.executeQuery(queryString);

            //populate tablesTabs
            List<ITab> tablesTabs = schemaPanel.tablesTabs;
            tablesTabs.removeAll(tablesTabs);
            while (resultSet.next())
            {
                final String table_name = resultSet.getString("table_name");
                final String utype = resultSet.getString("utype");
                final String description = resultSet.getString("description");

                //select columns from selected table
                String url2 = "jdbc:mysql://" + server + ":" + port + "/";
                Connection connection2 = null;
                Statement statement2 = null;
                ResultSet resultSet2 = null;
                Statement statement3 = null;
                ResultSet resultSet3 = null;
                Statement statement4 = null;
                ResultSet resultSet4 = null;
                try
                {
                    Class.forName("com.mysql.jdbc.Driver");
                    connection2 = DriverManager.getConnection(
                            url2,
                            username,
                            password
                    );
                    statement2 = connection2.createStatement();
                    String queryString2 = "SELECT * FROM " + tapschemaName + ".columns " + 
                            "WHERE table_name='" + table_name + "';";
                    resultSet2 = statement2.executeQuery(queryString2);

                    //populate rowsList
                    List<Row> rowsList = new ArrayList<Row>();
                    rowsList.removeAll(rowsList);
                    while (resultSet2.next())
                    {
                        String column_name = resultSet2.getString("column_name");
                        
                        //search if primary key
                        statement3 = connection2.createStatement();
                        String queryString3 = "SELECT key_id FROM " + tapschemaName + ".keys " +
                                "INNER JOIN " + tapschemaName + ".key_columns " +
                                "USING (key_id) " +
                                "WHERE " + tapschemaName + ".keys.from_table='" + table_name + "' " +
                                "AND " + tapschemaName + ".key_columns.from_column='" + column_name + "';";
                        resultSet3 = statement3.executeQuery(queryString3);
                        String primary_key = "";
                        if (resultSet3.next())
                        {
                            primary_key = "primary_key";
                        }
                        
                        //search if foreign key
                        statement4 = connection2.createStatement();
                        String queryString4 = "SELECT key_id FROM " + tapschemaName + ".keys " +
                                "INNER JOIN " + tapschemaName + ".key_columns " +
                                "USING (key_id) " +
                                "WHERE " + tapschemaName + ".keys.target_table='" + table_name + "' " +
                                "AND " + tapschemaName + ".key_columns.target_column='" + column_name + "';";
                        resultSet4 = statement4.executeQuery(queryString4);
                        String foreign_key = "";
                        if (resultSet4.next())
                        {
                            foreign_key = "foreign_key";
                        }
                        
                        rowsList.add(new Row(
                                false,
                                primary_key,
                                foreign_key,
                                table_name,
                                column_name,
                                resultSet2.getString("utype"),
                                resultSet2.getString("ucd"),
                                resultSet2.getString("unit"),
                                resultSet2.getString("description"),
                                resultSet2.getString("datatype"),
                                resultSet2.getInt("size"),
                                resultSet2.getInt("principal"),
                                resultSet2.getInt("indexed"),
                                resultSet2.getInt("std")));
                    }
                    final List<Row> finalRowsList = rowsList;

                    //create tablesTabs dynamically
                    tablesTabs.add(new AbstractTab(new Model<String>(table_name))
                    {
                        @Override
                        public Panel getPanel(String panelId)
                        {
                            TablePanel tablePanel = new TablePanel(
                                    panelId,
                                    finalRowsList,
                                    server,
                                    port,
                                    username,
                                    password,
                                    tapschemaName,
                                    new Schema(),
                                    new Table());
                            tablePanel.setOutputMarkupPlaceholderTag(true);
                            return tablePanel;
                        }    
                    });
                }
                catch (Exception exception)
                {
                    exception.printStackTrace();
                }
                finally
                {
                    try
                    {
                        resultSet4.close();
                        statement4.close();
                        
                        resultSet3.close();
                        statement3.close();
                        
                        resultSet2.close();
                        statement2.close();
                        connection2.close();
                    }
                    catch (Exception exception)
                    {
                        exception.printStackTrace();
                    }
                }
            }//end while
        }
        catch (Exception exception)
        {
            exception.printStackTrace();
        }
        finally
        {
            try
            {
                resultSet.close();
                statement.close();
                connection.close();
            }
            catch (Exception exception)
            {
                exception.printStackTrace();
            }
        }
    }
    
}
