/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package it.inaf.oats.ia2.tap.utils;

import it.inaf.oats.ia2.tap.utils.tapschema.TapSchema;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;
import org.apache.wicket.Component;
import org.apache.wicket.ajax.AjaxRequestTarget;
import org.apache.wicket.ajax.form.AjaxFormChoiceComponentUpdatingBehavior;
import org.apache.wicket.ajax.form.AjaxFormComponentUpdatingBehavior;
import org.apache.wicket.ajax.markup.html.form.AjaxSubmitLink;
import org.apache.wicket.behavior.AbstractBehavior;
import org.apache.wicket.markup.html.form.*;
import org.apache.wicket.model.IModel;
import org.apache.wicket.model.Model;

/**
 * SelectSchemataPage class extends the default BasePage.
 * SelectSchemataPage shows the ListMultipleChoice of databases with astronomical data and the
 * DropDownChoice of tap_schema databases both on the MySQL on hostname.
 * SelectSchemataPage permits to create a new tap_schema database or to edit an 
 * existing tap_schema database.
 * The databases exposed in the selected tap_schema are selected in the database
 * ListMultipleChoice.
 * 
 * @author pietro
 */
public class SelectSchemataPage extends BasePage {
    
    List<String> schemataList;
    List<String> tapschemaList;
    String tapschemaName;
    
    Form selectSchemataForm;
    ArrayList<String> selectedList;
    final ListMultipleChoice<String> schemataListChoice;
    final IModel<String> radioModel;
    ArrayList<String> selectedDrop;
    final DropDownChoice<String> tapschemaDropDownChoice;
    final TextField tapschemaTextField;
    final AjaxSubmitLink editTapschemaSubmit;
    final AjaxSubmitLink createTapschemaSubmit;
    RadioGroup<String> tapschemaRadioGroup;
    ArrayList<String> TYPES;
    final String selectedRadio;
    RadioChoice<String> tapschemaRadio;
    
    AjaxSubmitLink backSubmit;
    TextArea infoTextArea;
    
    /**
     * SelectSchemataPage constructor
     * 
     * @param target
     * @param form
     * @param hostname
     * @param port
     * @param username
     * @param password 
     */
    public SelectSchemataPage(
            final AjaxRequestTarget target,
            final Form<?> form,
            final String hostname,
            final String port,
            final String username,
            final String password)
    {        
        schemataList = new ArrayList<String>();       
        tapschemaList = new ArrayList<String>();
        
        //selectschemata form
        selectSchemataForm = new Form("selectSchemataForm");
        add(selectSchemataForm);
        
        selectedList = new ArrayList<String>(
		Arrays.asList(new String[] { }));
        //schemata listchoice
        schemataListChoice = new ListMultipleChoice<String>(
                "schemataListChoice",
                new Model(selectedList),
                schemataList);
        schemataListChoice.setOutputMarkupPlaceholderTag(true);
        selectSchemataForm.add(schemataListChoice);
        
        //model for tapschemaRadioGroup
        radioModel = new Model<String>("Existing Tapschema");
        
        selectedDrop = new ArrayList<String>(
                Arrays.asList(new String[] { }));
        //tapschema dropdownchoice
        tapschemaDropDownChoice = new DropDownChoice<String>(
                "tapschemaDropDownChoice",
                new Model(selectedDrop),
                tapschemaList)
        {
            //onSelectionChanged is not called: Wicket's bug? See on StackOverflow
            /*
            @Override
            protected void onSelectionChanged(String newSelection)
            {
                //load schemas from tapschema selected
                String url = "jdbc:mysql://" + hostname + ":" + port + "/";
                Connection connection = null;
                Statement statement = null;
                ResultSet resultSet = null;
                try
                {
                    Class.forName("com.mysql.jdbc.Driver");
                    connection = DriverManager.getConnection(
                            url,
                            username,
                            password
                    );
                    statement = connection.createStatement();
                    String queryString = "SELECT schema_name FROM " + newSelection + ".`schemas`;";
                    resultSet = statement.executeQuery(queryString);
                    
                    //compare schemas in tapschema with schemas in schemataListChoice
                    selectedList.removeAll(selectedList);
                    while (resultSet.next())
                    {
                        for (String schemaName : schemataList)
                        {
                            if (resultSet.getString(1).equals(schemaName))
                            {
                                selectedList.add(resultSet.getString(1));
                            }
                        }
                    }
                    schemataListChoice.setModelObject(selectedList);
                    target.add(schemataListChoice);
                }
                catch (Exception exception)
                {
                    infoTextArea.setModelObject((String)exception.getMessage());
                    target.add(infoTextArea);
                    exception.printStackTrace();
                }
                finally
                {
                    try
                    {
                        resultSet.close();
                        statement.close();
                        connection.close();
                    }
                    catch (Exception exception)
                    {
                        exception.printStackTrace();
                        return;
                    }
                }
            }
            */
        };
        tapschemaDropDownChoice.setOutputMarkupPlaceholderTag(true);
        tapschemaDropDownChoice.add(new AbstractBehavior()
        {
            /**
             * onConfigure method of the AbstractBehavior sets the visibility
             * of tapschemaDropDownChoice on the base of RadioChoice model.
             * 
             * @param component
             */
            @Override
            public void onConfigure(Component component)
            {
                if (radioModel.getObject().equals("Existing Tapschema"))
                {
                    component.setVisible(true);
                }
                else
                {
                    component.setVisible(false);
                }
            }
        });
        tapschemaDropDownChoice.add(new AjaxFormComponentUpdatingBehavior("onchange")
        {
            /**
             * onUpdate method of AjaxFormComponentUpdatingBehavior on the onchange event
             * gets the selected tap_schema from tapschemaDropDownChoice DropDownChoice
             * and selects the databases exposed in the selected tap_schema from
             * schemataListChoice ListMultipleChoice.
             * 
             * @param target
             */
            @Override
            protected void onUpdate(AjaxRequestTarget target)
            {
                // gets selected tap_schema from tapschemaDropDownChoice
                String newSelection = tapschemaDropDownChoice.getModelObject();
                
                // selects the databases exposed in the selected tap_schema from schemataListChoice
                selectDefaultSchema(target, hostname, port, username, password, newSelection);
            }
        });
        
        //tapschema textfield
        tapschemaTextField = new TextField(
                "tapschemaTextField",
                Model.of(""));
        tapschemaTextField.setOutputMarkupPlaceholderTag(true);
        tapschemaTextField.add(new AbstractBehavior()
        {
            /**
             * onConfigure method of the AbstractBehavior sets the visibility
             * of tapschemaTextField on the base of RadioChoice model.
             * 
             * @param component
             */
            @Override
            public void onConfigure(Component component)
            {
                if (radioModel.getObject().equals("New Tapschema"))
                {
                    component.setVisible(true);
                }
                else
                {
                    component.setVisible(false);
                }
            }
        });
                        
        //edit tapschema AjaxSubmitLink
        editTapschemaSubmit = new AjaxSubmitLink(
                "editTapschemaSubmit",
                selectSchemataForm)
        {
            @Override
            protected void onError(AjaxRequestTarget target, Form<?> form)
            {
                
            }
            
            /**
             * onSubmit method of editTapschemaSubmit AjaxSubmitLink creates a new
             * SchemaPage and populates its SchemaTabs by obtaining metadata from
             * all selected databases and from the tapschema itself
             * 
             * @param target
             * @param form
             */
            @Override
            protected void onSubmit(final AjaxRequestTarget target, Form<?> form)
            {
                try
                {
                    tapschemaName = tapschemaDropDownChoice.getModelObject();
                    UpdateTapSchema updateTapSchema = new UpdateTapSchema();
                    
                    // populates tapschema structure by obtaining metadata from all selected databases
                    Collection<String> selectedDatabases = schemataListChoice.getModelObject();
                    TapSchema tapschema = updateTapSchema.populateFromDatabases(
                            hostname,
                            port,
                            username,
                            password,
                            tapschemaName,
                            selectedDatabases,
                            false);
                    
                    // populate tapschema structure by obtaining metadata written
                    // in the tapschema database itself
                    tapschema = updateTapSchema.populateFromTapSchema(
                            hostname,
                            port,
                            username,
                            password,
                            tapschemaName,
                            selectedDatabases,
                            false,
                            tapschema);
                    
                    // loads all the databases with astronomical data to schemataListChoice
                    // and loads all the tap_schema databases to tapschemaDropDownChoice
                    loadSchemata(target, form, hostname, port, username, password);
                    
                    // creates a new SchemaPage
                    SchemaPage schemaPage = new SchemaPage(
                            target,
                            form,
                            hostname,
                            port,
                            username,
                            password,
                            tapschemaName,
                            tapschema);
                    
                    // populates SchemaTabs of SchemaPage
                    schemaPage.populateSchemaTabs(
                                target,
                                form,
                                hostname,
                                port,
                                username,
                                password,
                                tapschemaName,
                                tapschema);
                    
                    // passes to SchemaPage
                    setResponsePage(schemaPage);
                    
                    infoTextArea.setModelObject((String)(tapschemaName + " populated"));
                }
                catch (Exception exception)
                {
                    infoTextArea.setModelObject((String)exception.getMessage());
                    exception.printStackTrace();
                }
                finally
                {
                    target.add(infoTextArea);
                }
            }
        };
        editTapschemaSubmit.setOutputMarkupPlaceholderTag(true);
        editTapschemaSubmit.add(new AbstractBehavior()
        {
            /**
             * onConfigure method of the AbstractBehavior sets the visibility
             * of editTapSchemaSubmit on the base of RadioChoice model.
             * 
             * @param component
             */
            @Override
            public void onConfigure(Component component)
            {
                if (radioModel.getObject().equals("Existing Tapschema"))
                {
                    component.setVisible(true);
                }
                else
                {
                    component.setVisible(false);
                }
            }
        });
        
        //create tapschema AjaxSubmitLink
        createTapschemaSubmit = new AjaxSubmitLink(
                "createTapschemaSubmit",
                selectSchemataForm)
        {
            @Override
            protected void onError(AjaxRequestTarget target, Form<?> form)
            {
                
            }
            
            /**
             * onSubmit method of createTapschemaSubmit AjaxSubmitLink creates a new
             * tapschema database with default data, creates a new SchemaPage and
             * populates its SchemaTabs by obtaining metadata from all selected databases
             * and from the tapschema itself.
             * 
             * @param target
             * @param form
             */
            @Override
            protected void onSubmit(AjaxRequestTarget target, Form<?> form)
            {
                try
                {
                    tapschemaName = (String)tapschemaTextField.getModelObject();
                    UpdateTapSchema updateTapSchema = new UpdateTapSchema();
                    
                    Collection<String> selectedDatabases = schemataListChoice.getModelObject();
                    
                    // check conditions on databases
                    if (selectedDatabases.isEmpty())
                    {
                        infoTextArea.setModelObject((String)("No databases selected for " + tapschemaName));
                        return;
                    }
                    for (String databaseName : selectedDatabases)
                    {
                        if (tapschemaName.equals(databaseName))
                        {
                            infoTextArea.setModelObject((String)("Database " + tapschemaName + " already exists"));
                            return;
                        }
                    }
                    
                    // creates the tapschema database in MySQL on hostname
                    updateTapSchema.createTapSchemaDatabase(
                            hostname,
                            port,
                            username,
                            password,
                            tapschemaName);
                    /*
                    updateTapSchema.autoUpdateTapSchema(
                            hostname,
                            port,
                            username,
                            password,
                            tapschemaName);
                            */
                    // writes tapschema default metadata in the tapschema itself
                    updateTapSchema.selfUpdateTapSchema(
                            hostname,
                            port,
                            username,
                            password,
                            tapschemaName);
                    
                    // populates tapschema structure by obtaining metadata from all selected databases
                    selectedDatabases.add(tapschemaName);
                    TapSchema tapschema = updateTapSchema.populateFromDatabases(
                            hostname,
                            port,
                            username,
                            password,
                            tapschemaName,
                            selectedDatabases,
                            true);
                    
                    // populate tapschema structure by obtaining metadata written
                    // in the tapschema database itself
                    tapschema = updateTapSchema.populateFromTapSchema(
                            hostname,
                            port,
                            username,
                            password,
                            tapschemaName,
                            selectedDatabases,
                            true,
                            tapschema);

                    // loads all the databases with astronomical data to schemataListChoice
                    // and loads all the tap_schema databases to tapschemaDropDownChoice
                    loadSchemata(target, form, hostname, port, username, password);
                    
                    // creates a new SchemaPage
                    SchemaPage schemaPage = new SchemaPage(
                            target,
                            form,
                            hostname,
                            port,
                            username,
                            password,
                            tapschemaName,
                            tapschema);
                    
                    // populates SchemaTabs of SchemaPage
                    schemaPage.populateSchemaTabs(
                                target,
                                form,
                                hostname,
                                port,
                                username,
                                password,
                                tapschemaName,
                                tapschema);
                    
                    // passes to SchemaPage
                    setResponsePage(schemaPage);
                    
                    infoTextArea.setModelObject((String)(tapschemaName + " created and populated"));
                }
                catch (Exception exception)
                {
                    infoTextArea.setModelObject((String)exception.getMessage());
                    exception.printStackTrace();
                }
                finally
                {
                    target.add(infoTextArea);
                }
            }
        };
        createTapschemaSubmit.setOutputMarkupPlaceholderTag(true);
        createTapschemaSubmit.add(new AbstractBehavior()
        {
            /**
             * onConfigure method of the AbstractBehavior sets the visibility
             * of createTapSchemaSubmit on the base of RadioChoice model.
             * 
             * @param component
             */
            @Override
            public void onConfigure(Component component)
            {
                if (radioModel.getObject().equals("New Tapschema"))
                {
                    component.setVisible(true);
                }
                else
                {
                    component.setVisible(false);
                }
            }
        });
        
        //tapschema RadioGroup
        tapschemaRadioGroup = new RadioGroup("tapschemaRadioGroup", radioModel );
        tapschemaRadioGroup.add(new AjaxFormChoiceComponentUpdatingBehavior()
        {
            /**
             * onUpdate method of tapschemaRadioGroup sets the visibility of some
             * components on the base of its model, which changes with the selection
             * by the user.
             * 
             * @param target
             */
            @Override
            protected void onUpdate(AjaxRequestTarget target)
            {
                if (radioModel.getObject().equals("Existing Tapschema"))
                {
                    tapschemaDropDownChoice.setVisible(true);
                    tapschemaTextField.setVisible(false);
                    editTapschemaSubmit.setVisible(true);
                    createTapschemaSubmit.setVisible(false);
                }
                else
                {
                    tapschemaDropDownChoice.setVisible(false);
                    tapschemaTextField.setVisible(true);
                    editTapschemaSubmit.setVisible(false);
                    createTapschemaSubmit.setVisible(true);
                }
                target.add(tapschemaDropDownChoice);
                target.add(tapschemaTextField);
                target.add(editTapschemaSubmit);
                target.add(createTapschemaSubmit);
            }
        });
        tapschemaRadioGroup.add(new Radio<String>("radioExisting", Model.of("Existing Tapschema")));
        tapschemaRadioGroup.add(new Radio<String>("radioNew", Model.of("New Tapschema")));
        tapschemaRadioGroup.add(tapschemaDropDownChoice);
        tapschemaRadioGroup.add(tapschemaTextField);
        tapschemaRadioGroup.add(editTapschemaSubmit);
        tapschemaRadioGroup.add(createTapschemaSubmit);
        
	TYPES = new ArrayList<String>(
                Arrays.asList(new String[] { "Existing Tapschema", "New Tapschema" }));
	selectedRadio = "Existing Tapschema";
        //tapschema radiochoice
        tapschemaRadio = new RadioChoice<String>(
				"tapschemaRadio", new Model(selectedRadio), TYPES);
        selectSchemataForm.add(tapschemaRadioGroup);
        
        //back submit
        backSubmit = new AjaxSubmitLink(
                "backSubmit",
                selectSchemataForm)
        {
            @Override
            protected void onError(AjaxRequestTarget target, Form<?> form)
            {
                
            }
            
            /**
             * onSubmit method of backSubmit AjaxSubmitLink sends back to CredentialPage.
             * 
             * @param target
             * @param form
             */
            @Override
            protected void onSubmit(AjaxRequestTarget target, Form<?> form)
            {
                try
                {
                    setResponsePage(CredentialPage.class);
                }
                catch (Exception exception)
                {
                    infoTextArea.setModelObject((String)exception.getMessage());
                    target.add(infoTextArea);
                    exception.printStackTrace();
                }
            }
        };
        selectSchemataForm.add(backSubmit);
        
        //info textarea
        infoTextArea = new TextArea("infoTextArea", Model.of(""));
        infoTextArea.setOutputMarkupPlaceholderTag(true);
        infoTextArea.setEnabled(false);
        selectSchemataForm.add(infoTextArea);
        
        // loads all the databases with astronomical data to schemataListChoice
        // and loads all the tap_schema databases to tapschemaDropDownChoice
        loadSchemata(target, form, hostname, port, username, password);
        
        // if there are tap_schema databases, select the first as default
        if (!tapschemaList.isEmpty())
        {
            //String newSelection = tapschemaDropDownChoice.getModelObject();
            String newSelection = tapschemaList.get(0);
            tapschemaDropDownChoice.setModelObject(newSelection);
            selectDefaultSchema(target, hostname, port, username, password, newSelection);
        }
    }
    
    /**
     * loadSchemata method searches all the databases with astronomical data and
     * shows them in schemataListChoice, then searches all the tap_schema databases
     * and shows them in tapschemaDropDownChoice.
     * 
     * @param target
     * @param form
     * @param hostname
     * @param port
     * @param username
     * @param password 
     */
    public void loadSchemata(
            AjaxRequestTarget target,
            Form<?> form,
            String hostname,
            String port,
            String username,
            String password)
    {
        // opens the connection to MySql on hostname
        String url = "jdbc:mysql://" + hostname + ":" + port + "/";
        Connection connection = null;
        Statement statement = null;
        ResultSet resultSet = null;
        try
        {
            Class.forName("com.mysql.jdbc.Driver");
            connection = DriverManager.getConnection(
                    url,
                    username,
                    password
            );
            // searches all database on hostname
            statement = connection.createStatement();
            String queryString = "SHOW DATABASES;";
            resultSet = statement.executeQuery(queryString);
            schemataList.removeAll(schemataList);
            while (resultSet.next())
            {
                schemataList.add(resultSet.getString(1)); 
            }
            // updates schemataListChoice
            schemataListChoice.setChoices(schemataList);
            target.add(schemataListChoice);
        }
        catch (Exception exception)
        {
            infoTextArea.setModelObject((String)exception.getMessage());
            target.add(infoTextArea);
            exception.printStackTrace();
            return;
        }
        finally
        {
            try
            {
                resultSet.close();
                statement.close();
                connection.close();
            }
            catch (Exception exception)
            {
                exception.printStackTrace();
                return;
            }
        }

        // finds tap_schema
        try
        {
            tapschemaList.removeAll(tapschemaList);
            Class.forName("com.mysql.jdbc.Driver");
            connection = DriverManager.getConnection(
                    url,
                    username,
                    password
            );
            for (String schema : schemataList)
            {
                // searches if the current database has schemas, tables, columns,
                // keys, key_columns, that is a tap_schema database
                statement = connection.createStatement();
                String queryString = "SHOW TABLES FROM " + schema + ";";
                resultSet = statement.executeQuery(queryString);
                boolean schemas = false;
                boolean tables = false;
                boolean columns = false;
                boolean keys = false;
                boolean key_columns = false;
                while (resultSet.next())
                {
                    if (resultSet.getString(1).equals("schemas"))
                    {
                        schemas = true;
                    }
                    else if (resultSet.getString(1).equals("tables"))
                    {
                        tables = true;
                    }
                    else if (resultSet.getString(1).equals("columns"))
                    {
                        columns = true;
                    }
                    else if (resultSet.getString(1).equals("keys"))
                    {
                        keys = true;
                    }
                    else if (resultSet.getString(1).equals("key_columns"))
                    {
                        key_columns = true;
                    }
                }
                // if database has schemas, tables, columns, keys and key_columns
                // then it is a tap_schema database
                if ((schemas == true) && 
                        (tables == true) &&
                        (columns == true) &&
                        (keys == true) &&
                        (key_columns == true))
                {
                    tapschemaList.add(schema);
                }
            }
            // updates tapschemaDropDownChoice
            tapschemaDropDownChoice.setChoices(tapschemaList);
            target.add(tapschemaDropDownChoice);
        }
        catch (Exception exception)
        {
            infoTextArea.setModelObject((String)exception.getMessage());
            target.add(infoTextArea);
            exception.printStackTrace();
        }
        finally
        {
            try
            {
                resultSet.close();
                statement.close();
                connection.close();
            }
            catch (Exception exception)
            {
                exception.printStackTrace();
            }
        }
    }
    
    /**
     * 
     * @param target
     * @param hostname
     * @param port
     * @param username
     * @param password
     * @param newSelection selected tap_schema database
     */
    public void selectDefaultSchema(
            AjaxRequestTarget target,
            String hostname,
            String port,
            String username,
            String password,
            String newSelection)
    {                
        //loads schemas from selected tapschema
        String url = "jdbc:mysql://" + hostname + ":" + port + "/";
        Connection connection = null;
        Statement statement = null;
        ResultSet resultSet = null;
        try
        {
            Class.forName("com.mysql.jdbc.Driver");
            connection = DriverManager.getConnection(
                    url,
                    username,
                    password
            );
            statement = connection.createStatement();
            String queryString = "SELECT schema_name FROM " + newSelection + ".`schemas`;";
            resultSet = statement.executeQuery(queryString);

            //compares schemas in tapschema with schemas in schemataListChoice
            selectedList.removeAll(selectedList);
            while (resultSet.next())
            {
                for (String schemaName : schemataList)
                {
                    if (resultSet.getString(1).equals(schemaName))
                    {
                        selectedList.add(resultSet.getString(1));
                    }
                }
            }
            // updates schemataListChoice
            schemataListChoice.setModelObject(selectedList);
            target.add(schemataListChoice);
        }
        catch (Exception exception)
        {
            infoTextArea.setModelObject((String)exception.getMessage());
            target.add(infoTextArea);
            exception.printStackTrace();
        }
        finally
        {
            try
            {
                resultSet.close();
                statement.close();
                connection.close();
            }
            catch (Exception exception)
            {
                exception.printStackTrace();
                return;
            }
        }
    }
        
}
