/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package it.inaf.oats.ia2.tap.utils;

import it.inaf.oats.ia2.tap.utils.tapschema.Column;
import it.inaf.oats.ia2.tap.utils.tapschema.Schema;
import it.inaf.oats.ia2.tap.utils.tapschema.Table;
import java.util.List;
import org.apache.wicket.extensions.markup.html.tabs.AbstractTab;
import org.apache.wicket.markup.html.panel.Panel;
import org.apache.wicket.model.Model;

/**
 * TableTab class extends AbstractTab class.
 * TableTab class gets the current TablePanel.
 * 
 * @author pietro
 */
public class TableTab extends AbstractTab{
    
    final TablePanel tablePanel;
    
    /**
     * TableTab constructor
     * 
     * @param rowsList rows list to populate "rows" DataGridView in TablePanel
     * @param hostname
     * @param port
     * @param username
     * @param password
     * @param tapschemaName
     * @param schema current schema structure
     * @param table current table structure
     */
    public TableTab(
            List<Row> rowsList,
            final String hostname,
            final String port,
            final String username,
            final String password,
            final String tapschemaName,
            Schema schema,
            Table table)
    {
        super(new Model<String>(table.table_name));
        
        String panelId = "panel";
        
        tablePanel = new TablePanel(
                panelId,
                rowsList,
                hostname,
                port,
                username,
                password,
                tapschemaName,
                schema,
                table);
        tablePanel.setOutputMarkupPlaceholderTag(true);
    }
    
    @Override
    public Panel getPanel(String panelId)
    {
        return tablePanel;
    }
    
}
